]> TLD Linux GIT Repositories - packages/rpm-tld-macros.git/blob - macros.tld
- remove tmpfiles.d checks, there is no systemd in TLD Linux
[packages/rpm-tld-macros.git] / macros.tld
1 # vim:ts=4 sw=4 noet ft=spec
2 #
3 # TLD Linux rpm macros.
4 # <https://www.tld-linux.org/>
5
6 # can be used by builder script to check for version
7 %rpm_build_macros       {Revision}
8
9 %epoch          0
10 %x8664          x86_64 amd64 ia32e
11
12 # compiler version
13 %cc_version     %{expand:%%global cc_version %(%{__cc} -dumpversion 2>/dev/null || echo 0.0)}%cc_version
14 %cxx_version    %{expand:%%global cxx_version %(%{__cxx} -dumpversion 2>/dev/null || echo 0.0)}%cxx_version
15
16 %__rm           /bin/rm --interactive=never
17
18 # Build system path macros.
19 %__autoconf     autoconf %{?debug:-Wall}
20 %__automake     automake -a -c -f --foreign
21 %__autopoint    autopoint --force
22
23 # add parallel build flags: -jN
24 # jobs macro is available since 1.657
25 #
26 # if you want to disable parallel build do:
27 # echo '%__jobs %{nil}' >> ~/.rpmmacros
28 %__jobs         %{expand:%%global __jobs %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); [ "$_NCPUS" -gt 3 ] && echo $(($_NCPUS / 2)))%%{nil}}%__jobs
29
30 # expands to -jN if %__jobs has a value
31 %_smp_mflags    %{expand:%%global _smp_mflags %(jobs=%{__jobs}; echo ${jobs:+-j$jobs}%%{nil})}%_smp_mflags
32
33 %__make         /usr/bin/make %{?_make_opts} %{?_smp_mflags}
34 %__scons        /usr/bin/scons %{?_smp_mflags}
35 %__waf          /usr/bin/waf %{?_smp_mflags}
36 %__cmake        /usr/bin/cmake -Wno-dev
37 %__meson        /usr/bin/meson
38 %__meson_wrap_mode      nodownload
39 %__ninja        /usr/bin/ninja
40 %__ninja_common_opts    -v %{?_smp_mflags}
41
42 %__gettextize { \
43         gettextize --copy --force --no-changelog; \
44         if [ ! -f po/Makevars ]; then \
45                 cp -f po/Makevars{.template,}; \
46         fi; \
47 }
48
49 %__glib_gettextize      glib-gettextize --copy --force
50 %__gnome_doc_common     gnome-doc-common --copy
51 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
52 %__gtkdocize            gtkdocize --copy
53 %__intltoolize          intltoolize --copy --force
54 %__libtoolize           libtoolize --copy --force --install
55
56 # topdir is where builder script lives,
57 # fallback to old style if SPECS/SOURCES dirs were found.
58 %_topdir    %{expand:%%global _topdir %(
59         if [ -d SPECS -a -d SOURCES ]; then
60                 # old style rpmdir: in topdir
61                 pwd
62         elif [ -d ../SPECS -a -d ../SOURCES ]; then
63                 # old style rpmdir: in subdir
64                 cd ..; pwd
65         elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
66                 # if old style rpm dir exist, go with it
67                 echo $HOME/rpm; \
68         elif [ -x ../builder -a ! -d ../builder ]; then
69                 # relative new style rpmdir: in package dir
70                 cd ..; pwd
71         elif [ -x builder -a ! -d builder ]; then
72                 # relative new style rpmdir: in packages
73                 pwd
74         elif [ -x packages/builder -a ! -d packages/builder ]; then
75                 # relative new style rpmdir: packages dir in current dir
76                 cd packages; pwd
77         else
78                 # fallback to new style rpmdir
79                 echo $HOME/rpm/packages
80         fi; \
81 )}%_topdir
82
83 # if %{_topdir}/SPECS exists, it's old style structure
84 %_specdir               %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
85 %_sourcedir             %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
86
87 # BUILD/RPMS/SRPMS are on same level by default as packages dir, if these exist
88 # if they don't exist assume we are having custom topdir (which is not named as
89 # "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
90 # NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therefore the extra echo
91 %_builddir              %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
92 %_rpmdir                %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
93 %_srcrpmdir             %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
94
95 #       The number of cvs changelog entries kept when building package.
96 %_buildchangelogtruncate 20
97
98 %dependencytracking     %{nil}
99
100 #       Relations between package names that cause dependency loops
101 #       with legacy packages that cannot be fixed. Relations are
102 #       specified as
103 #               p>q
104 #       where package p has a Requires: on something that package q Provides:
105 #
106 # XXX   Note: that there cannot be any whitespace within the string "p>q",
107 #       and that both p and q are package names (i.e. no version/release).
108 %_dependency_whiteout   %{nil}
109
110 #-----------------------------------------------------------------
111 #
112 # (re)definition of %{rpm*flags} with %filterout_* support
113 # BuildRequires:        awk
114 # BuildRequires:        rpmbuild(macros) >= 1.315
115 #
116 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
117 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
118 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
119 # %rpmcppflags  = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
120 # %rpmldflags   = %optldflags - %filterout_ld
121 #
122 # Regular expressions are supported, but to avoid some character be treated
123 # as regular expression it must be escaped twice.
124
125 %filter_out                                                     \
126         for (i = 1; i in I; i++) { A=0; \
127                 for (f in F) {                          \
128                         if (I[i] ~ "^" F[f] "$") A=1;   \
129                 };                                                      \
130                 if (!A) printf(I[i] FS);        \
131         }
132
133 %rpmcflags %(awk 'BEGIN {
134         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
135         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
136         %{filter_out}
137 }')
138
139 %rpmcxxflags %(awk 'BEGIN {
140         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
141         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
142         %{filter_out}
143 }')
144
145 %rpmcppflags %(awk 'BEGIN {
146         split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
147         split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
148         %{filter_out}
149 }')
150
151 %rpmldflags %(awk 'BEGIN {
152         split("%{?optldflags}",I);
153         split("%{?filterout_ld}",F)
154         %{filter_out}
155 }')
156
157 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
158 # but, don't use it, better use gcc as linker
159 %ld_rpmldflags %(awk 'BEGIN {
160         split("%{rpmldflags}",F);
161         for (f in F) {
162                 s = F[f];
163                 if (s ~ /^-Wl,/) {
164                         s = substr(s,5);
165                         gsub(/,/," ",s);
166                 };
167                 printf(s FS);
168         };
169 }')
170
171 #-----------------------------------------------------------------
172 #
173 #  Generate a command which cleans environment, leaving only the
174 # most important variables.
175 #  If any spec requires any additional environment it should
176 # redefine %_preserve_env in following manner:
177 #
178 #       # ADDITIONAL_VAR is required because [a good reason here]
179 #       %define _preserve_env ADDITIONAL_VAR
180
181 %_preserve_env_base     PATH HOME TMP TMPDIR SSH_AUTH_SOCK
182
183 # "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
184 %_clean_env env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
185         split("%{?_preserve_env:%_preserve_env %_preserve_env_base}%{!?_preserve_env:%_preserve_env_base}", P);
186         for (i in P) {
187                 p = P[i];
188                 if (!ENVIRON[p] || d[p]) {
189                         continue;
190                 }
191                 d[p] = 1;
192                 split(ENVIRON[p], V, "");
193                 val = p "=";
194                 for (j = 1; j in V; j++) {
195                         v = V[j];
196                         if (v == q)
197                                 v = qq;
198                         else if (v == "\\"")
199                                 v = q2q;
200                         else if (v == "\\\\")
201                                 v = "\\\\\\\\";
202                         else
203                                 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
204                         val = val "" v;
205                 }
206                 printf(val " ");
207         }
208 }')
209
210 # override %__spec_build_pre and %__spec_install_pre from macros.rpmbuild
211 # adding %{_clean_env}
212 %__spec_build_pre       %{_clean_env}\
213 %{___build_pre}\
214 %{nil}
215 %__spec_install_pre     %{_clean_env}\
216 %{___build_pre}\
217 %{?buildroot:%{__rm} -rf '%{buildroot}'; %{__mkdir_p} '%{buildroot}'}\
218 %{nil}
219
220 #-----------------------------------------------------------------
221 %configure2_13 { \
222  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
223  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
224  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
225  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
226  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
227  FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
228  CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
229  %{?__cc:CC="%{__cc}" ; export CC ; } \
230  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
231  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
232         --host=%{_target_platform} \
233         --prefix=%{_prefix} \
234         --exec-prefix=%{_exec_prefix} \
235         --bindir=%{_bindir} \
236         --sbindir=%{_sbindir} \
237         --sysconfdir=%{_sysconfdir} \
238         --datadir=%{_datadir} \
239         --includedir=%{_includedir} \
240         --libdir=%{_libdir} \
241         --libexecdir=%{_libexecdir} \
242         --localstatedir=%{_localstatedir} \
243         --sharedstatedir=%{_sharedstatedir} \
244         --mandir=%{_mandir} \
245         --infodir=%{_infodir} \
246         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
247         %{dependencytracking} \
248 }
249
250 # Note: pass only standard cmake macros here.
251 # The only exception is SYSCONF_INSTALL_DIR, used commonly in KDE packages,
252 # where the default (${CMAKE_INSTALL_PREFIX}/etc) is not FHS-compliant and
253 # absolute path MUST be used to comply with FHS.
254 # The other non-standard cmake macros used commonly in KDE
255 # (INCLUDE_INSTALL_DIR, LIB_INSTALL_DIR, SHARE_INSTALL_PREFIX)
256 # have sane default values in KDE, and some packages use these names
257 # in different way (e.g. expect them to be always relative or always
258 # absolute).
259 %cmake \
260 %{?__cc:CC="${CC:-%{__cc}}"} \\\
261 %{?__cxx:CXX="${CXX:-%{__cxx}}"} \\\
262 CPPFLAGS="${CPPFLAGS:-%{rpmcppflags}}" \\\
263 %{__cmake} \\\
264         -DCMAKE_VERBOSE_MAKEFILE=ON \\\
265         -DCMAKE_BUILD_TYPE=%{!?debug:TLD}%{?debug:Debug} \\\
266         -DCMAKE_INSTALL_BINDIR:PATH=%{_bindir} \\\
267         -DCMAKE_INSTALL_SBINDIR:PATH=%{_sbindir} \\\
268         -DCMAKE_INSTALL_LIBEXECDIR:PATH=%{_libexecdir} \\\
269         -DCMAKE_INSTALL_SYSCONFDIR:PATH=%{_sysconfdir} \\\
270         -DCMAKE_INSTALL_SHAREDSTATEDIRPATH:PATH=%{_sharedstatedir} \\\
271         -DCMAKE_INSTALL_LOCALSTATEDIRPATH:PATH=%{_localstatedir} \\\
272         -DCMAKE_INSTALL_LIBDIR:PATH=%{_libdir} \\\
273         -DCMAKE_INSTALL_INCLUDEDIR:PATH=%{_includedir} \\\
274         -DCMAKE_INSTALL_OLDINCLUDEDIR:PATH=%{_includedir} \\\
275         -DCMAKE_INSTALL_DATAROOTDIR:PATH=%{_datadir} \\\
276         -DCMAKE_INSTALL_DATADIR:PATH=%{_datadir} \\\
277         -DCMAKE_INSTALL_INFODIR:PATH=%{_infodir} \\\
278         -DCMAKE_INSTALL_LOCALEDIR:PATH=%{_localedir} \\\
279         -DCMAKE_INSTALL_MANDIR:PATH=%{_mandir} \\\
280         -DCMAKE_INSTALL_DOCDIR:PATH=%{_docdir} \\\
281         -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} \\\
282         -DSYSCONF_INSTALL_DIR:PATH=%{_sysconfdir} \\\
283         -DCMAKE_CXX_FLAGS_TLD="${CXXFLAGS:-%{rpmcxxflags} -DNDEBUG -DQT_NO_DEBUG}" \\\
284         -DCMAKE_C_FLAGS_TLD="${CFLAGS:-%{rpmcflags} -DNDEBUG -DQT_NO_DEBUG}" \\\
285         -DCMAKE_Fortran_FLAGS_TLD="${CFLAGS:-%{rpmcflags} -DNDEBUG -DQT_NO_DEBUG}" \\\
286         -DCMAKE_EXE_LINKER_FLAGS_TLD="${LDFLAGS:-%{rpmldflags}}" \\\
287         -DCMAKE_SHARED_LINKER_FLAGS_TLD="${LDFLAGS:-%{rpmldflags}}" \\\
288         -DCMAKE_MODULE_LINKER_FLAGS_TLD="${LDFLAGS:-%{rpmldflags}}" \\\
289 %if "%{_lib}" == "lib64" \
290         -DLIB_SUFFIX=64 \\\
291 %endif \
292 %if "%{_lib}" == "libx32" \
293         -DLIB_SUFFIX=x32 \\\
294 %endif \
295         -DBUILD_SHARED_LIBS:BOOL=ON \\\
296 %{nil}
297
298 %scons { \
299 %{__scons} \
300         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
301         CFLAGS="${CFLAGS:-%rpmcflags}" \
302         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
303         FFLAGS="${FFLAGS:-%rpmcflags}" \
304         CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
305         %{?__cc:CC="%{__cc}"} \
306         %{?__cxx:CXX="%{__cxx}"} \
307         libsuffix=%{_lib} \
308         prefix=%{_prefix} \
309 }
310
311 # waf. see waf.spec
312 %waf { \
313 CC="%{__cc}" \
314 CXX="%{__cxx}" \
315 CPP="%{__cpp}" \
316 CFLAGS="%{rpmcflags}" \
317 CXXFLAGS="%{rpmcxxflags}" \
318 LINKFLAGS="%{rpmldflags}" \
319 %{__waf} \
320 }
321
322 # meson
323 %meson { \
324 %{?__cc:CC="${CC:-%{__cc}}"} \
325 %{?__cxx:CXX="${CXX:-%{__cxx}}"} \
326 CFLAGS="${CFLAGS:-%{rpmcflags}}" \
327 CPPFLAGS="${CPPFLAGS:-%{rpmcppflags}}" \
328 CXXFLAGS="${CXXFLAGS:-%{rpmcxxflags}}" \
329 LDFLAGS="${LDFLAGS:-%{rpmldflags}}" \
330 LC_ALL=C.UTF-8 %{__meson} \
331         --buildtype=plain \
332         --bindir=%{_bindir} \
333         --datadir=%{_datadir} \
334         --includedir=%{_includedir} \
335         --infodir=%{_infodir} \
336         --libdir=%{_libdir} \
337         --libexecdir=%{_libexecdir} \
338         --localedir=%{_localedir} \
339         --localstatedir=%{_localstatedir} \
340         --mandir=%{_mandir} \
341         --prefix=%{_prefix} \
342         --sbindir=%{_sbindir} \
343         --sharedstatedir=%{_sharedstatedir} \
344         --sysconfdir=%{_sysconfdir} \
345         --wrap-mode=%{__meson_wrap_mode} \
346         --default-library='both' \
347 }
348
349 %___meson_deprecate() {echo >&2 "DEPRECATED: %%%1 must be replaced with %%%2"; %{expand:%%%2} }
350 %meson_build %___meson_deprecate meson_build ninja_build
351 %meson_install %___meson_deprecate meson_install ninja_install
352 %meson_test %___meson_deprecate meson_test ninja_test
353
354 # ninja
355 %ninja_build LC_ALL=C.UTF-8 %{__ninja} %{__ninja_common_opts}
356 %ninja_install LC_ALL=C.UTF-8 DESTDIR=%{buildroot} %{__ninja} install %{__ninja_common_opts}
357 %ninja_test LC_ALL=C.UTF-8 %{__ninja} test %{__ninja_common_opts}
358
359 #----------------------------------------------------------------
360 #%configure_cache 0
361 %configure_cache_file   %{buildroot}.configure.cache
362
363 %configure {./configure \
364         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
365         CFLAGS="${CFLAGS:-%rpmcflags}" \
366         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
367         FFLAGS="${FFLAGS:-%rpmcflags}" \
368         FCFLAGS="${FCFLAGS:-%rpmcflags}" \
369         CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
370         %{?__cc:CC="%{__cc}"} \
371         %{?__cxx:CXX="%{__cxx}"} \
372         --host=%{_target_platform} \
373         --build=%{_target_platform} \
374         --prefix=%{_prefix} \
375         --exec-prefix=%{_exec_prefix} \
376         --bindir=%{_bindir} \
377         --sbindir=%{_sbindir} \
378         --sysconfdir=%{_sysconfdir} \
379         --datadir=%{_datadir} \
380         --includedir=%{_includedir} \
381         --libdir=%{_libdir} \
382         --libexecdir=%{_libexecdir} \
383         --localstatedir=%{_localstatedir} \
384         --sharedstatedir=%{_sharedstatedir} \
385         --mandir=%{_mandir} \
386         --infodir=%{_infodir} \
387         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
388         %{dependencytracking} \
389         %{?configure_cache:--cache-file=%{configure_cache_file}} \
390 }
391
392 # Simple macros to simplify adding bconded options to configure scripts.
393 #   Each macro requires bcond name and accepts optional option name, if option
394 # isn't specified bcond name is used as option name. Options returning
395 # --with and --enable also allow third argument which will be added as value
396 # ( --with-option=value or --enable-option=value ) in case or positive
397 # condition, but won't be added otherwise ( nothing or just --disable-option ).
398
399 # Requirements:
400 # BuildRequires: rpmbuild(macros) >= 1.527
401
402 # Usage example:
403 # %{__enable bcond} - returns --enable-bcond iff build condition is set
404 # %{__disable bcond option} - returns --enable-option iff bcond is not set
405 # %{__enable_disable bcond option value} - returns --enable-option=value if
406 #    bcond is set, returns --disable-option otherwise
407
408 # expand bconds to --enable-something and --disable-something
409 %__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
410 %__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
411 %__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
412
413 # same as above, but condition inverted
414 %__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
415 %__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
416 %__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
417
418 # expand bconds to --with-something and --without-something
419 %__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
420 %__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
421 %__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
422
423 # same as above, but condition inverted
424 %__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
425 %__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
426 %__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
427
428 # expands to true or false based on bcond; for use with meson or cmake
429 %__true_false() %{expand:%%{?with_%{1}:true}%%{!?with_%{1}:false}}
430 %__true_false_not() %{expand:%%{?with_%{1}:false}%%{!?with_%{1}:true}}
431
432 # for use with cmake:
433 # Usage: cmake_on_off BCOND_NAME [OPTION_NAME]
434 # BuildRequires: rpmbuild(macros) >= 1.742
435 %cmake_on_off() -D%{?2}%{!?2:%{1}}:BOOL=%{expand:%%{?with_%{1}:ON}%%{!?with_%{1}:OFF}}
436
437 #-----------------------------------------------------------------
438
439 # overload to insert debuginfo package
440 %prep \
441 %if 0%{?_enable_debug_packages}\
442 %{debug_package}\
443 %endif\
444 %%prep\
445 %{nil}
446
447 # Location of autoconf macros
448 %_aclocaldir    %{expand:%%global _aclocaldir %(aclocal --print-ac-dir 2>/dev/null || echo ERROR)}%_aclocaldir
449
450 # Location of omf files
451 %_omf_dest_dir  %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
452
453 # Location of pkgconfig files
454 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
455 # noarch pkgconfig files
456 %_npkgconfigdir /usr/share/pkgconfig
457
458 # Location of desktop files
459 %_desktopdir    /usr/share/applications
460 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
461
462 # Location of pixmaps for applnk/desktop files
463 %_pixmapsdir    /usr/share/pixmaps
464
465 # Location of themable icons for applnk/desktop files
466 %_iconsdir      /usr/share/icons
467
468 # Location of fonts directories
469 %_fontsdir      /usr/share/fonts
470
471 # Location of Gtk and associated libraries documentation
472 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
473
474 # Location of KDE documentation
475 %_kdedocdir     %{_defaultdocdir}/kde/HTML
476
477 # unsermake script
478 %__unsermake /usr/share/unsermake/unsermake
479
480 # Current date
481 %date           %(LC_ALL=C date +"%a %b %d %Y")
482
483 # Example files, programs, scripts...
484 %_examplesdir   /usr/src/examples
485
486 # SysV-style initscripts dir
487 %_initddir              /etc/rc.d/init.d
488
489 # If non-empty "debug" macro defined, add "dbg" suffix to release number
490 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
491
492 # Bootstrap release macros.
493 # Usage:
494 #       %bcond_with     bootstrap
495 #       Release:        %{bootstrap_release 1}
496 #
497 # Package will have release 1 if built normally,
498 # and release 0.zzz.bootstrap if built with bootstrap
499 %bootstrap_release() %{!?with_bootstrap:%{1}%{?2:.%{2}}}%{?with_bootstrap:%{!?2:%(expr %{1} - 1)}%{?2:%{1}.%(expr %{2} - 1)}.zzz.bootstrap}
500
501 # Requires name = version-release
502 %requires_releq()       %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
503 # Requires: name = version
504 %requires_eq()          %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
505 # Requires: name = version (version based on querying package %2)
506 %requires_eq_to(r)      %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
507
508 # Requires: name >= version
509 %requires_ge()          %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_ge_to %1 %1}}}
510 # Requires: name >= version (version based on querying package %2)
511 %requires_ge_to(r)      %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 >= %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
512
513 # helper for renaming packages
514 # %rename old-package
515 %rename() \
516 Obsoletes: %{1} < %{?epoch:%{epoch}:}%{?version:%{version}}%{?release:-%{release}} \
517 Provides: %{1} = %{?epoch:%{epoch}:}%{?version:%{version}}%{?release:-%{release}}
518
519 %apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
520
521 # sgml macros
522 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
523 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
524 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
525 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
526 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
527 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
528 %docbook_sgmlcat_fix() { for l in \
529 '' \
530 '  -- default decl --' \
531 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
532 '  -- hacks for opensp --' \
533 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
534 'SYSTEM   "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
535 '' \
536 ; do echo $l; done >> %1 \
537 }
538
539 # vim - "
540
541 # minimum file size needed for compressed documents.
542 # just smaller files than this get larger when compressed.
543 # some stats:
544 # - 0 byte file compressed was 25 bytes .gz
545 # - 39 byte file was compressed as 57
546 # - with test/test.spec@man 158 byte file was compressed also 158
547 %_min_compress_bytes    159
548
549 #-----------------------------------------------------------------
550 # find and gzip all files in %{_mandir} and %{infodir}
551 #
552 # Requires: xargs, find
553 #
554 #%no_install_post_compress_docs 1
555 %__spec_install_post_compress_docs { \
556 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
557         %{!?debug:set +x;} \
558         for i in /usr/share/man /usr/X11R6/man; do \
559                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
560                         echo "Compress man pages: $i"; \
561                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print0 | xargs -0 -r %{__bzip2} -df; \
562                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print0 | xargs -0 -r %{__gzip} -dnf; \
563                         find $RPM_BUILD_ROOT$i -type l | while read a; do \
564                                 m=$(readlink "$a"); \
565                                 if [[ "$m" = */* ]]; then \
566                                         # handle links to different man section \
567                                         l=$(readlink -f "$a"); \
568                                         # full/relative paths that resolve symlink \
569                                         l=${l#$RPM_BUILD_ROOT/usr/share/man/}; \
570                                         l=${l#$RPM_BUILD_ROOT/usr/X11R6/man/}; \
571                                         # full paths that do not resolve symlink \
572                                         l=${l#/usr/share/man/}; \
573                                         l=${l#/usr/X11R6/man/}; \
574                                 else \
575                                         l=${a#$RPM_BUILD_ROOT$i/}; \
576                                         l=${l%/*}; \
577                                         l="$l/$m"; \
578                                 fi; \
579                                 rm -f $a; \
580                                 echo ".so $l" > $a; \
581                                 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: $l"; \
582                         done; \
583                         # verify that .so links point to existing files (not allowed to point to "other package") \
584                         # TODO: iterate over all man dirs, but in Th there is only one true man dir \
585                         err=$(grep -rl '^\.so ' "$RPM_BUILD_ROOT$i" | while read doc; do \
586                                 l=$(grep -r '^\.so ' "$doc"); \
587                                 l=${l#.so }; \
588                                 d=$(dirname $doc); \
589                                 test -e $RPM_BUILD_ROOT$i/$l || test -e $d/$(basename $l) || echo "  ${doc#$RPM_BUILD_ROOT} points to inexistent manpage: $l"; \
590                         done); \
591                         test "$err" != "" && { echo >&2 "Man page link errors:"; echo >&2 "$err"; exit 1; }; \
592                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print0 | xargs -0 -r %{__gzip} -9nf; \
593                 fi; \
594         done; \
595         if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
596                 echo "Compress info pages: %{_infodir}"; \
597                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print0 | xargs -0 -r %{__bzip2} -df; \
598                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print0 | xargs -0 -r %{__gzip} -dnf; \
599                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print0 | xargs -0 -r %{__gzip} -9nf; \
600         fi; \
601 }; __spec_install_post_compress_docs } }
602
603 #-----------------------------------------------------------------
604 # Strip executable binaries and shared object files
605 #
606 # Requires: find, awk, strip, cut, xargs
607 #
608 # Special macros which affect this process:
609 #%no_install_post_strip 1               # disable stripping at all
610 #%_noautostrip                  regexp  # exclude files matching (anchored!) regex from stripping
611 #%_autostripall                 regexp  # strip files matching (anchored!) regex using plain strip
612 #%_autostripunneeded    regexp  # strip files matching (anchored!) regex using strip --strip-unneeded
613 #%_autostripdebug               regexp  # strip files matching (anchored!) regex using strip --strip-debug
614 #
615 %__spec_install_post_strip {%{!?debug: \
616 %{!?no_install_post_strip:__spec_install_post_strip() { \
617 %{!?debug:set +x;} \
618 if [ -d "$RPM_BUILD_ROOT" ]; then \
619         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
620                 modulelist=$(find $RPM_BUILD_ROOT/lib/modules \( -name '*.o' -o -name '*.ko' \) -type f -print); \
621                 if [ "$modulelist" ]; then \
622                         modulecount=$(echo "$modulelist" | wc -l); \
623                         printf "Stripping %d kernel modules..." $modulecount; \
624                         echo "$modulelist" | xargs -l512 chmod u+w; \
625                         echo "$modulelist" | xargs -l512 %{__strip} -g --remove-section=.comment --remove-section=.note.GNU-stack; \
626                         echo "DONE"; \
627                 fi; \
628         fi; \
629         filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[x0-9]*/debug/.*\.debug" ! -regex ".*/usr/lib[x0-9]*.*/guile/.*\.go" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
630         if [ -n "$filelist" ]; then \
631                 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
632                 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
633                 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
634                 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
635                 if [ -n "$elfexelist" ]; then \
636                         printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
637                         echo "$elfexelist" | xargs -r -d'\n' chmod u+w; \
638                         echo "$elfexelist" | xargs -r -d'\n' %{__strip} --remove-section=.note --remove-section=.comment; \
639                         echo "DONE"; \
640                 fi; \
641                 if [ -n "$elfsharedlist" ]; then \
642                         printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
643                         echo "$elfsharedlist" | xargs -r -d'\n' chmod u+w; \
644                         echo "$elfsharedlist" | xargs -r -d'\n' %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment; \
645                         echo "DONE"; \
646                 fi; \
647                 if [ -n "$archiveslist" ]; then \
648                         printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
649                         echo "$archiveslist" | xargs -r -d'\n' chmod u+w; \
650                         echo "$archiveslist" | xargs -r -d'\n' %{__strip} --strip-debug --remove-section=.note --remove-section=.comment; \
651                         echo "DONE"; \
652                 fi; \
653         fi; \
654     filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
655     filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
656     filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
657         if [ -n "$filelist_all" ]; then \
658                 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
659                 chmod u+w $filelist_all; \
660                 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
661                 echo "DONE"; \
662         fi; \
663         if [ -n "$filelist_unneeded" ]; then \
664                 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
665                 chmod u+w $filelist_unneeded; \
666                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
667                 echo "DONE"; \
668         fi; \
669         if [ -n "$filelist_debug" ]; then \
670                 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
671                 chmod u+w $filelist_debug; \
672                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
673                 echo "DONE"; \
674         fi; \
675 fi; }; __spec_install_post_strip } } }
676
677 #-----------------------------------------------------------------
678 # remove all RPATH/RUNPATH from executable binaries and shared object files
679 #
680 # Requires: find, awk, cut, xargs, chrpath, uname
681 #
682 # Special macros which affect this process
683 #%no_install_post_chrpath       1       # disable chrpath at all
684 #%_noautochrpath        regex           # exclude files matching (anchored!) regex from chrpath
685 #
686 %__spec_install_post_chrpath {%{!?debug: \
687 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
688 %{!?debug:set +x;} \
689 if [ -d "$RPM_BUILD_ROOT" ]; then \
690         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
691         if [ -n "$files" ]; then \
692                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
693         fi; \
694         if [ -n "$objs" ]; then \
695                 printf "Remove RPATH/RUNPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
696                 echo "$objs" | \
697                 while read file; do \
698                         rpath= ; \
699                         chmod u+w "$file"; \
700                         for dir in $(chrpath -l "$file" | awk '/(R|RUN)PATH=/ { gsub(/.*RPATH=/,""); gsub(/.*RUNPATH=/,""); gsub(/:/," "); print $0 }'); do \
701                                         case $dir in \
702                                         '$ORIGIN' ) \
703                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
704                                                 else rpath="$rpath:$dir" ; fi ; \
705                                                 continue ; \
706                                                 ;; \
707                                         esac ; \
708                                         newdir=$(readlink -m "$dir"); \
709                                         [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
710                                         case $dir in \
711                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
712                                                 echo "remove-rpath: $dir in $file"; \
713                                                 ;; \
714                                         * ) \
715                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
716                                                 else rpath="$rpath:$dir" ; fi ; \
717                                                 ;; \
718                                         esac ; \
719                         done ; \
720                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
721                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
722                 done; \
723         fi; \
724 fi; }; __spec_install_post_chrpath } } }
725
726 # vim: "
727
728 #-----------------------------------------------------------------
729 # Find all shared object files with unresolved symbols. Warn
730 # and terminate if any found (termination can be turned off by define).
731 #%no_install_post_check_so 1
732 #%skip_post_check_so libwithunresolvedok.so.*
733 #
734 # NOTE: define skip_post_check_so only if such library really requires
735 #       unresolved symbols and always leave a comment why it is required:
736 #       # executable provides symbols foo, bar for those libraries:
737 #       %define skip_post_check_so libwithoutfoo.so.* libwithoutbar.so.*
738 #
739 %__spec_install_post_check_so { \
740 __spec_install_post_check_so() { \
741 %{!?debug:set +x;} \
742         fail=0; \
743         printf "Searching for shared objects with unresolved symbols..."; \
744         for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
745                 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; skip["_ZSt15__once_callable"]=1; skip["_ZSt11__once_call"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; %{?skip_post_check_so:split("%{skip_post_check_so}", R); for (i=1; i in R; i++) { if (file ~ "(^|/)" R[i] "$") { print "Library marked with skip_post_check_so, ignoring errors.\n"; exit(0); } } } exit(1); } } ' || fail=1 ; \
746         done ; \
747         echo " DONE"; \
748         %{!?no_install_post_check_so:return $fail;} \
749 }; __spec_install_post_check_so }}
750
751 #-----------------------------------------------------------------
752 # Find all ELF files with executable stac. Warn and terminate if any found
753 # (termination can be turned off by define).
754 # Details: https://wiki.gentoo.org/wiki/Hardened/GNU_stack_quickstart
755 #%no_install_post_check_stackexec 1
756 #%skip_post_check_stackexec libwithexecstackok.so.*
757 #
758 # NOTE: define skip_post_check_stackexec only if such program or library
759 #       really requires executable stack and always leave a comment why
760 #       it is required:
761 #       # Programs full of nested functions that cannot be fixed
762 #       %define skip_post_check_execstack /bin/foo libwithexecstack.so.*
763 #
764 %__spec_install_post_check_execstack { \
765 __spec_install_post_check_execstack() { \
766 %{!?debug:set +x;} \
767         fail=0; \
768         printf "Searching for ELF programs with executable stack..."; \
769         for f in $(find $RPM_BUILD_ROOT -type f -print) ; do \
770                 LC_ALL=C readelf -lW $f 2>/dev/null | \
771                 LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; } /GNU_STACK/ { if ($7 ~ "E") { found=1 } } END { if (found) { print "\nExecutable stack found in: " file; %{?skip_post_check_execstack:split("%{skip_post_check_execstack}", R); for (i=1; i in R; i++) { if (file ~ "(^|/)" R[i] "$") { print "File marked with skip_post_check_execstack, ignoring errors.\n"; exit(0); } } } exit(1); } }' || fail=1 ; \
772         done ; \
773         echo " DONE"; \
774         %{!?no_install_post_check_execstack:return $fail;} \
775 }; __spec_install_post_check_execstack }}
776
777 #-----------------------------------------------------------------
778 # Do not verify if each directory under /var/run contains
779 # tmpfiles.d configuration. TLD Linux doesn't use tmpfiles.d.
780 #
781 %no_install_post_check_tmpfiles 1
782 #
783 %__spec_install_post_check_tmpfiles %{nil}
784
785 #-----------------------------------------------------------------
786 # Verify that scripts have reasonable shebangs
787 # Test spec: see "test/spec_install_post_check_shebangs" branch on packages/test.spec
788 #
789 #%no_install_post_check_shebangs 1
790 #
791 %__spec_install_post_check_shebangs { \
792 __spec_install_post_check_shebangs() { \
793 %{!?debug:set +x;} \
794         echo "Checking script shebangs..."; \
795         fail=` \
796         find $RPM_BUILD_ROOT -type f -perm -500 -print | { fail=0; while IFS= read -r f; do \
797                 shebang="$(sed -e'1s/#! *\(.*\)/\1/;t;d;q' "$f")" ; \
798                 f="${f##$RPM_BUILD_ROOT}"; \
799                 case "$shebang" in \
800                         "%{__python}"|"%{__python3}"|"%{__python} "*|"%{__python3} "* \
801                         |"/usr/bin/python%{py_ver}"|"/usr/bin/python%{py_ver} "* \
802                         |"/usr/bin/python%{py3_ver}"|"/usr/bin/python%{py3_ver} "*) \
803                                 ;; \
804                         "/usr/bin/env python"*|"/usr/bin/python"|"/usr/bin/python "*) \
805                                 echo "$f starts with '#!$shebang', should be '#!%{__python}' or '#!%{__python3}'" >&2;\
806                                 fail=1 ; \
807                                 ;; \
808                         "/usr/bin/env "*) \
809                                 echo "$f starts with '#!$shebang', should be explicit interpreter path" >&2;\
810                                 fail=1 ; \
811                                 ;; \
812                         *) ;;\
813                 esac ; \
814         done ; \
815         echo "$fail" ; \
816         }`; \
817         echo " DONE" ; \
818         %{!?no_install_post_check_shebangs:return $fail;} \
819 }; __spec_install_post_check_shebangs }}
820
821 # Remove common Perl files we don't package
822 %__spec_install_post_perl_clean {\
823 %{!?no_install_post_perl_clean: \
824 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
825 } }
826
827 # Helpers to specify SONAME depdendencies, e.g.:
828 #   Requires: %{_soname_prov libfoo.so.1}
829 #   Requires: %{_soname_prov libfoo.so.1(SOME_SYMVER)}
830 #
831 # BuildRequires:        rpmbuild(macros) >= 1.721
832 #
833 %_soname_tag %(echo %{_lib} | sed -e 's/^lib//' -e 's/^\\(.\\+\\)$/(\\1bit)/')
834 %_soname_prov() %(echo "%{1}()%{_soname_tag}" | sed -e 's/^\\([^(]*([^)]\\+)\\)()%{_soname_tag}$/\\1%{_soname_tag}/;s/()$//')
835
836 #-----------------------------------------------------------------
837 # Update GConf2 schemas
838 #
839 # Requires: GConf2
840 #
841 %gconf_schema_install() \
842         umask 022; \
843         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
844         /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
845 %{nil}
846
847 %gconf_schema_uninstall() \
848 if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
849         umask 022; \
850         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
851         /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
852 fi; \
853 %{nil}
854
855 #-----------------------------------------------------------------
856 # Update desktop MIME database
857 # requires: desktop-file-utils
858 %update_desktop_database() {{ \
859         umask 022; \
860         /usr/bin/update-desktop-database -q; \
861 };} \
862 %{nil}
863
864 %update_desktop_database_post %update_desktop_database
865
866 %update_desktop_database_postun() {{ \
867 if [ "$1" = "0" ]; then \
868         %update_desktop_database \
869 fi; \
870 };} \
871 %{nil}
872
873 #-----------------------------------------------------------------
874 # Update shared MIME info database
875 # requires: shared-mime-info
876 # Note: https://bugs.freedesktop.org/show_bug.cgi?id=70366#c19
877 #       https://bugzilla.redhat.com/show_bug.cgi?id=1052173
878 # TODO: if you want this running with fdatasync(), make sure it's:
879 #       1. announcing ~minute delay by echoing appropriate message,
880 #       2. running only once after rpm transaction.
881 #
882 %update_mime_database() {{ \
883         umask 022; \
884         PKGSYSTEM_ENABLE_FSYNC=0 \
885         /usr/bin/update-mime-database %{_datadir}/mime; \
886 };} \
887 %{nil}
888
889 #-----------------------------------------------------------------
890 # Update icon cache
891 # BuildRequires:        rpmbuild(macros) >= 1.596
892 # Requires:             hicolor-icon-theme
893 #
894 %update_icon_cache() {{ \
895         %{!?1:%{error:%{0}: Required theme name missing}} \
896         if [ -x /usr/bin/gtk-update-icon-cache ]; then \
897                 umask 022; \
898                 touch --no-create %{_iconsdir}/%1; \
899                 /usr/bin/gtk-update-icon-cache -qf %{_iconsdir}/%1; \
900         fi; \
901 };} \
902 %{nil}
903
904 #-----------------------------------------------------------------
905 # Update scrollkeeper database
906 # requires: scrollkeeper
907 #
908 %scrollkeeper_update_post() \
909         /usr/bin/scrollkeeper-update -q; \
910 %{nil}
911
912 %scrollkeeper_update_postun() \
913 if [ "$1" = "0" ]; then \
914         /usr/bin/scrollkeeper-update -q; \
915 fi; \
916 %{nil}
917
918 #-----------------------------------------------------------------
919 # Compile GSettings schemas
920 # requires: glib2 >= 1:2.26.0
921 #
922 %glib_compile_schemas() {{ \
923         umask 022; \
924         /usr/bin/glib-compile-schemas %{_datadir}/glib-2.0/schemas; \
925 };} \
926 %{nil}
927
928 #-----------------------------------------------------------------
929 # post %install sequence:
930 # - autodeps exceptions
931 # - compress all man and info pages,
932 # - strip all ELF executables and ELF shared objects if not %debug.
933 # - compress kernel modules if any
934
935 ###################################################################
936 # Requires/Provides automation
937 # exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
938 #
939 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
940 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
941 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
942 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov) \
943         %{?_noautoprov: %{_noautoprov}} \
944         %{?_noautoprov_java: %{__noauto_regexp_helper -p java %{_noautoprov_java}}} \
945         %{?_noautoprov_mono: %{__noauto_regexp_helper -p mono %{_noautoprov_mono}}} \
946         %{?_noautoprov_pear: %{__noauto_regexp_helper -p pear %{_noautoprov_pear}}} \
947         %{?_noautoprov_perl: %{__noauto_regexp_helper -p perl %{_noautoprov_perl}}} \
948         %{?_noautoprov_pyegg: %{__noauto_regexp_helper -p pythonegg %{_noautoprov_pyegg}}} \
949         %{?_noautoprov_py3egg: %{__noauto_regexp_helper -p python3egg %{_noautoprov_py3egg}}} \
950         %{nil}
951 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq) \
952         %{?_noautoreq: %{_noautoreq}} \
953         %{?_noautoreq_java: %{__noauto_regexp_helper -p java %{_noautoreq_java}}} \
954         %{?_noautoreq_mono: %{__noauto_regexp_helper -p mono %{_noautoreq_mono}}} \
955         %{?_noautoreq_pear: %{__noauto_regexp_helper -p pear %{_noautoreq_pear}}} \
956         %{?_noautoreq_perl: %{__noauto_regexp_helper -p perl %{_noautoreq_perl}}} \
957         %{?_noautoreq_pyegg: %{__noauto_regexp_helper -p pythonegg %{_noautoreq_pyegg}}} \
958         %{?_noautoreq_py3egg: %{__noauto_regexp_helper -p python3egg %{_noautoreq_py3egg}}} \
959         %{nil}
960
961 # helper for wrapping _noautoreq between perl() or pear()
962 # Author: Elan Ruusamäe <glen@pld-linux.org>
963 # Usage:
964 # BuildRequires:        rpmbuild(macros) >= 1.654
965 # %define _noautoreq_pear Excluded.php PEAR/Something.php
966 # %define _noautoreq_perl Apache::.*
967 # BuildRequires:        rpmbuild(macros) >= 1.672
968 # %define _noautoreq_java ClassDataVersion
969 # BuildRequires:        rpmbuild(macros) >= 1.709
970 # %define _noautoreq_pyegg argparse
971 # %define _noautoreq_py3egg backports.ssl-match-hostname ipaddress
972 # BuildRequires:        rpmbuild(macros) >= 1.730
973 # %define _noautoreq_mono Gendarme.Framework
974 # BuildRequires:        rpmbuild(macros) >= 1.737
975 # %define _noautoprov_java Class
976 # %define _noautoprov_mono Excluded.Provide
977 # %define _noautoprov_pear Excluded.php
978 # %define _noautoprov_perl Excluded::Module
979 # %define _noautoprov_pyegg excluded
980 # %define _noautoprov_py3egg excluded3
981 #
982 %__noauto_regexp_helper(p:) %(echo "%*" | awk 'BEGIN{RS=" "}{printf("%{-p*}%{__qchar}(%%s%{__qchar}) ", $1)}')
983 # detect quote character runtime
984 %__qchar_4 \\\\%{nil}
985 %__qchar_5 \\\\\\%{nil}
986 %__qchar %{expand:%%global __qchar %%__qchar_%(echo %{_rpmversion} | cut -c1)}%__qchar
987
988 #%_noautocompressdoc    %{nil}
989 #
990 %_missing_doc_files_terminate_build     1%{nil}
991 %_unpackaged_files_terminate_build      %{nil}
992
993 # node.js libdir
994 # Requirements:
995 # BuildRequires: rpmbuild(macros) >= 1.634
996 %nodejs_libdir          /usr/lib/node_modules
997
998 # bash-completion 2.0 completions dir
999 # Requirements:
1000 # BuildRequires:        rpmbuild(macros) >= 1.673
1001 # Requires:     bash-completion >= 2.0
1002 %bash_compdir           /usr/share/bash-completion/completions
1003
1004 # fish completions dir
1005 # Requirements:
1006 # BuildRequires:        rpmbuild(macros) >= 1.720
1007 %fish_compdir           /usr/share/fish/vendor_completions.d
1008
1009 # zsh completions dir
1010 # Requirements:
1011 # BuildRequires:        rpmbuild(macros) >= 1.719
1012 %zsh_compdir            /usr/share/zsh/site-functions
1013
1014 # depmod macro
1015 %depmod() { \
1016 umask 022; \
1017 if [ -e /boot/System.map-%1 ]; then \
1018         /sbin/depmod -a -F /boot/System.map-%1 %1; \
1019 else \
1020         if [ -e /boot/System.map ]; then \
1021                 /sbin/depmod -a -F /boot/System.map %1; \
1022         else \
1023                 /sbin/depmod -a %1; \
1024         fi \
1025 fi; \
1026 }
1027
1028 # user/group checking macros
1029 #
1030 # Usage:
1031 #       %userremove myuser
1032 #
1033 %userremove     /usr/lib/rpm/user_group.sh user del
1034 %groupremove    /usr/lib/rpm/user_group.sh group del
1035 #
1036 # Usage:
1037 #       if %usertestrm myuser; then
1038 #               /usr/sbin/userdel -r myuser
1039 # Note:
1040 #       use these macros only if you need to call userdel/groupdel with
1041 #       a non-standard option or take an extra action; otherwise use the
1042 #       %userremove/%groupremove macros
1043 #
1044 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
1045 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
1046 # user group membership management macros
1047 #
1048 # Usage:
1049 #       %addusertogroup [-q] myuser agroup
1050 #
1051 #  -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1052 #
1053 # Requirements:
1054 # BuildRequires:        rpmbuild(macros) >= 1.515
1055 %addusertogroup(q)      quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1056 %{nil}
1057
1058 # banner support (useful in {pre,post}{,un} and triggers)
1059 #
1060 # Usage:
1061 #       %banner name [-a] [-e] [-n] [-tn] [-o] <<EOF
1062 # the banner text, the banner text
1063 # the banner text, and following line
1064 #EOF
1065 # You can use any form of here-document, <<'EOF' <<-EOT will do.
1066 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1067 #
1068 # -a    - append to the banner
1069 # -e    - send to stderr instead of stdout
1070 # -n    - don't show banner (overrides -t)
1071 # -t    - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
1072 # -o    - show only once, i.e when package is installed for the first time
1073 #
1074 # Tests:
1075 # (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1076 # (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1077 # (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m 1
1078 # rpm -E 'date | %banner -e banner' > m; sh -x m
1079 # rpm -E 'date | %banner -o -e banner' > m; sh -x m
1080 #
1081 %banner(aenot:) %{-o:([ "$1" != 1 ] ||} ( \
1082 RPM_SCRIPTVERBOSITY=5 \
1083 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1084 if [ -x /usr/bin/banner.sh ]; then \
1085         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1086 else \
1087         CMD="cat%{-e: >&2}" \
1088 fi \
1089 eval $CMD %{?2:%2}%{?3: %3})%{-o:)} \
1090 %{nil}
1091
1092 # useradd/groupadd macros
1093 # Author: Elan Ruusamäe <glen@pld-linux.org>
1094 #
1095 # Usage:
1096 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1097 #   [-g initial_group] [-G group[,...]] login
1098 #
1099 #  -u uid. REQUIRED
1100 #  -g gid/group. REQUIRED
1101 #  -s defaults to /bin/false
1102 #  -d defaults to /usr/share/empty
1103 #  -c No default
1104 #  -r is accepted but ignored (it's always set)
1105 #  -k skeleton dir. defaults to /usr/share/empty
1106 # rpm specific flags
1107 #  -P package name. defaults to %{name}
1108 #
1109 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
1110 %{!-u:%{error:useradd: Required argument -u missing}} \
1111 %{!-g:%{error:useradd: Required argument -g missing}} \
1112 %{!?1:%{error:useradd: Required parameter login missing}} \
1113 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1114         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1115                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1116                 exit 1 \
1117         fi \
1118 else \
1119         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1120         /usr/sbin/useradd \\\
1121                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
1122                 -u %{-u*} \\\
1123                 -r \\\
1124                 -d %{-d*}%{!-d:/usr/share/empty} \\\
1125                 -s %{-s*}%{!-s:/bin/false} \\\
1126                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
1127                 -g %{-g*} \\\
1128                 %{-M} \\\
1129                 %{-G:-G %{-G*}} \\\
1130                 %{expand:%{%{#}}} 1>&2 || exit $? \
1131         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
1132 fi;
1133 # vim: "
1134
1135 # Usage:
1136 #   %groupadd [-P package] [-g gid] group
1137 #
1138 # -g gid. REQUIRED
1139 #
1140 # Sample:
1141 #   %groupadd -P %{name}-base -g %{gid} %{name}
1142
1143 %groupadd(g:P:rfo)      \
1144 %{!-g:%{error:groupadd: Required argument -g missing}} \
1145 %{!?1:%{error:groupadd: Required parameter group missing}} \
1146 if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
1147         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1148                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1149                 exit 1 \
1150         fi \
1151 else \
1152         echo "Adding group %{1} GID=%{-g*}." \
1153         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
1154         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
1155 fi;
1156
1157 # service macro.
1158 # Author: Elan Ruusamäe <glen@pld-linux.org>
1159 #
1160 # calls usual service restart on package %post, but skips the restart if
1161 # administrator has disabled automatic service restarts in either global
1162 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1163 #
1164 # Usage:
1165 #   %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
1166 #
1167 #  -q be silent when service isn't started (for scriplets restaring other package's services)
1168 #  -n NOOP mode, do not actually restart service
1169 #
1170 # Requirements:
1171 # BuildRequires:        rpmbuild(macros) >= 1.268
1172 # Requires:     rc-scripts
1173 # -n option:
1174 # BuildRequires:        rpmbuild(macros) >= 1.450
1175 %service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1} RPM_BUILD_ROOT=%{buildroot}; /usr/lib/rpm/service_generator.sh %{*}) };}
1176
1177 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1178
1179 # patchset macros
1180 # generate SourceX urls from range START STOP
1181 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1182 # The sources start from 10000
1183 #
1184 # Author: Elan Ruusamäe <glen@pld-linux.org>
1185 #
1186 # Usage:
1187 #   %patchset_source -f <seq(1) format> <start> [<end>]
1188 #   %patchset_patch <start> [<end>]
1189 # If <end> is omited, it is assumed to be <start>.
1190 #
1191 # For example in preamble:
1192 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1193 # and in %prep:
1194 #  %patchset_patch 33 44
1195 #
1196 # Using sources list:
1197 #   BuildRequires:      rpmbuild(macros) >= 1.426
1198 #   %patchset_source -f <url> -s <filelist>
1199 #   %patchset_patch -s <filelist>
1200 # For example (ncurses):
1201 #   BuildRequires:      rpmbuild(macros) >= 1.683
1202 #   %patchset_source -f ftp://dickey.his.com/ncurses/%{basever}/ -s sources
1203 #   %patchset_patch -s sources -p1
1204 #
1205
1206 %patchset_source(f:b:s:) %(
1207         base=%{-b*}%{!-b*:10000}
1208 %{-s:
1209         baseurl='%{-f*}'
1210         filelist='%{-s*}'
1211         i=$base
1212         while read checksum file; do
1213                 printf "Patch%d: %s%s\\n" $i "$baseurl" "$file"
1214                 i=$((i+1))
1215         done < $filelist
1216 }
1217 %{!-s:
1218         start=$(expr $base + %1);
1219         end=$(expr $base + %{?2}%{!?2:%{1}});
1220         # we need to call seq twice as it doesn't allow two formats
1221         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1222         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1223         paste %{tmpdir}/__ps{1,2};
1224         rm -f %{tmpdir}/__ps{1,2};
1225 }
1226 ) \
1227 %{nil}
1228
1229 # apply sources from %patchset_source
1230 # -p specify -pX for %patch line
1231 # -b base offset: defaults to 10000
1232 # -s filelist to read files from
1233 %patchset_patch(f:p:b:s:) %(
1234         base=%{-b*}%{!-b*:10000}
1235         patchlevel=%{-p*:-p%{-p*}}
1236 %{-s:
1237         filelist='%{-s*}'
1238         i=$base
1239         while read checksum file; do
1240                 printf "patch%d %s\\n" $i "$patchlevel" | sed -e s,^,%%,
1241                 i=$((i+1))
1242         done < $filelist
1243 }
1244 %{!-s:
1245         start=$(expr $base + %1);
1246         end=$(expr $base + %{?2}%{!?2:%{1}});
1247         echo ": patchset_patch %1%{?2: to %2}";
1248         seq -f "patch%g $patchlevel" $start $end | sed -e s,^,%%,;
1249 }
1250 ) \
1251 %{nil}
1252
1253 # return EXPANDED source url N from current spec
1254 %sourceurl(n:) %(test "$IN_RPM" = 1 && exit 1; export IN_RPM=1; rpmbuild --nodigest --nosignature --nobuild -D "prep %%dump" %{_specdir}/%{name}.spec 2>&1 | awk '$2 ~ /^SOURCEURL%{-n*}/ {print $3}')
1255
1256 # Helper for LUA.
1257 # split string separated by space into quoted list
1258 #
1259 # Author: Elan Ruusamäe <glen@pld-linux.org>
1260 #
1261 # %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1262 %__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1263
1264 # adjust /etc/shells by adding and removing shells from there
1265 # Author: Elan Ruusamäe <glen@pld-linux.org>
1266 #
1267 # Usage:
1268 #   %post       -p <lua>
1269 #   %lua_add_etc_shells /bin/sh /bin/pdksh
1270 #
1271 #   %preun      -p <lua>
1272 #   if arg[2] == 0 then
1273 #       %lua_remove_etc_shells /bin/bash /bin/rbash
1274 #   end
1275 #
1276 # Requirements:
1277 # BuildRequires:        rpmbuild(macros) >= 1.462
1278 #
1279
1280 %lua_add_etc_shells() \
1281 t = {}\
1282 f = io.open("/etc/shells", "r")\
1283 if f then\
1284         for l in f:lines() do t[l]=l; end\
1285         f:close()\
1286 end\
1287 for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1288         if not t[s] then\
1289                 print("Adding "..s.." to /etc/shells")\
1290                 f = io.open("/etc/shells", "a")\
1291                 if f then\
1292                         f:write(s.."\\n")\
1293                         f:close()\
1294                 end\
1295         end\
1296 end\
1297 %{nil}
1298
1299 %lua_remove_etc_shells() \
1300 t = {}\
1301 f = io.open("/etc/shells", "r")\
1302 if f then\
1303         for l in f:lines() do t[l]=l; end\
1304         f:close()\
1305 end\
1306 for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1307         print("Removing "..l.." from /etc/shells")\
1308         t[l] = nil\
1309 end\
1310 s=""\
1311 for _, l in pairs(t) do\
1312         s=s..l.."\\n"\
1313 end\
1314 f = io.open("/etc/shells", "w")\
1315 if f then\
1316         f:write(s)\
1317         f:close()\
1318 end\
1319 %{nil}
1320
1321 # Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1322 #
1323 # Author: Elan Ruusamäe <glen@pld-linux.org>
1324 #
1325 # Usage:
1326 #   %post       -p %add_etc_shells -p /bin/sh /bin/pdksh
1327 #   %preun      -p %remove_etc_shells -p /bin/sh /bin/pdksh
1328 #
1329 #  -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1330 #
1331 # Requirements:
1332 # BuildRequires:        rpmbuild(macros) >= 1.429
1333 #
1334 %add_etc_shells(p) %{-p:<lua>}\
1335 %{expand:%%lua_add_etc_shells %*}\
1336 %{nil}
1337
1338 %remove_etc_shells(p) %{-p:<lua>}\
1339 %{-p:if arg[2] == 0 then}\
1340 %{expand:%%lua_remove_etc_shells %*}\
1341 %{-p:end} \
1342 %{nil}
1343
1344 # Undos files
1345 #
1346 # Author: Paweł Zuzelski <pawelz@pld-linux.org>
1347 # Author: Elan Ruusamäe <glen@pld-linux.org>
1348 #
1349 # Usage:
1350 #   %undos list_of_files
1351 #   %undos -f EXT[,EXT]
1352 #   %undos -i -f EXT[,EXT]
1353 #
1354 #  -f EXT[,EXT] - find(1) files by extensions
1355 #  -i - case insensitive file search
1356 #
1357 # Example:
1358 #   Un-DOS all *.js, *.css files
1359 #   %undos -f js,css
1360 #   Un-DOS all *.js, *.JS files
1361 #   %undos -f js -i
1362 #   undos all Makefiles
1363 #   %{__find} -name Makefile | xargs %undos
1364 #
1365 # Requirements:
1366 # BuildRequires:        sed >= 4.0
1367 # BuildRequires:        rpmbuild(macros) >= 1.674
1368
1369 # NB: make sure this macro stays on one line
1370 # NB: make sure it includes newline escape
1371 %undos(f:i)     %{-f:%{__find} -type f -regextype posix-extended -%{-i:i}regex '^.+\\.(%(echo %{-f*} | tr ',' '|'))$' -print0 | xargs -0} %{__sed} -i -e 's,\\r$,,' %* \
1372 %{nil}
1373
1374 #-----------------------------------------------------------------
1375 # Update hardware database index
1376 #
1377 # Requirements:
1378 # BuildRequires:        rpmbuild(macros) >= 1.691
1379 # Requires:             udev-core >= 1:196
1380
1381 %udev_hwdb_update() \
1382 /sbin/udevadm hwdb --update >/dev/null 2>&1 || : \
1383 %{nil}
1384
1385 # Generate vim help tags file
1386 #
1387 # Requirements:
1388 # BuildRequires:        rpmbuild(macros) >= 1.718
1389 # Requires(post,postun):        /usr/bin/vim
1390 # Requires(post,postun):        vim-rt >= 4:7.4.2054-2
1391 %vim_doc_helptags() \
1392 umask 022; \
1393 /usr/bin/vim -c ':helptags /usr/share/vim/doc' -c ':q' 2>/dev/null \
1394 %{nil}
1395
1396 # EOF